ad_page_contract {

    group-edit.tcl
    Admin Page for Conference Groups
    @author Bjoern Kiesbye, Luis Mosteiro Fernandez
    @creation-date 2002-10-16
} {
    {user_prefix ""}
    {group_prefix ""}
     group_id:notnull
     group_name:notnull
    {list_members "true"}
} -properties {

}

set multi ""

multirow create partys party_id name

if {$user_prefix != ""} {

    set multi users

    db_foreach get_users_from_prefix "SELECT person_id , first_names , last_name FROM persons p WHERE lower(p.last_name) like(lower('$user_prefix%'))" {


           multirow append partys $person_id "$first_names $last_name"
       } if_no_rows {

         set multi ""
     }
} elseif { $group_prefix != ""} {

    set multi groups

    db_foreach get_users_from_prefix "SELECT (group_id) as cur_group_id , (group_name) as cur_group_name FROM groups g WHERE lower(g.group_name) like(lower('$group_prefix%'))" {


           multirow append partys $cur_group_id $cur_group_name
       } if_no_rows {

         set multi ""
     }


} 





if {$list_members == "true" } {
multirow create users_list  name rel_id member_state

db_foreach get_users_from_this_group "SELECT  (p.last_name) as last_name , (p.first_names) as first_names , (gmm.rel_id) as rel_id , (mr.member_state) as member_state
                                      FROM persons p, group_member_map gmm, membership_rels mr 
                                      WHERE gmm.group_id = :group_id
                                      AND gmm.group_id = gmm.container_id
                                      AND gmm.member_id = p.person_id
                                      AND mr.rel_id = gmm.rel_id" {

                        multirow append users_list  "$first_names $last_name" $rel_id $member_state

		    } if_no_rows {

		    }




multirow create groups_list  name rel_id



db_foreach get_users_from_this_group " SELECT  (g.group_name) as name,  (gcm.rel_id) as rel_id
                                      FROM groups g , group_component_map gcm 
                                      WHERE gcm.group_id = :group_id
                                      AND gcm.component_id  = g.group_id " {

                        multirow append groups_list $name $rel_id 

		    } if_no_rows {

		    }


}

ad_form -name user_search -action group-edit\#result -form {
    {group_id:text(hidden) {value $group_id}}
    {group_name:text(hidden) {value $group_name}}
    {list_members:text(hidden) {value $list_members}}
    {user_prefix:text(text) {label ""}}
    {sub1:text(submit) {label "Search User"}}
}

ad_form -name group_search -action group-edit\#result -form {
    {group_id:text(hidden) {value $group_id}}
    {group_name:text(hidden) {value $group_name}}
    {list_members:text(hidden) {value $list_members}}
    {group_prefix:text(text) {label ""}}
    {sub2:text(submit) {label "Search Group"}}
}
