ad_page_contract {

    site to display all users online
    @author Luis Mosteiro Fernandez, lmosteiro@sussdorff-roy.com
    @author Bjoern Kiesbye, bkiesbye@sussdorff-roy.com
    @creation-date 2003-03-26
    @param prefix display users depending on this prefix

} {

    {prefix "A"}

} -properties {

}

set all_invisible [util::whos_online::all_invisible_user_ids]
if {[llength $all_invisible] == 0 } {lappend all_invisible  0}
set all_users [util::whos_online::all_user_ids]

set context [list "Online users"]

set user_id [ad_conn user_id]
auth::require_login

set any_is_online_p 0

multirow create prefix_links prefix
set prefix_list [list A B C D E F G H I J K L M N O P Q R S T U V W X Y Z All]
for {set j 0} { $j < [llength $prefix_list]} {incr j} {
    multirow append prefix_links [lindex $prefix_list $j]
}

multirow create other_status any_user_id any_screen_id first_names last_name service status create_jid chat


# query to get users within the OACS who are online in Jabber and who are not explicit friends

if {![string equal $prefix "All"]} { 

db_foreach get_all_other_users_online "
    select pr.first_names , pr.last_name , 
    (pr.person_id) as any_user_id , sn.screen_id, sn.status, sn.service, sn.im_screen_name
    from persons pr , jb_screens sn 
    where pr.person_id = sn.user_id
    and lower(pr.last_name) like(lower('$prefix%')) 
    and sn.user_id != :user_id
    and sn.user_id NOT IN [tcl_to_oracle_list $all_invisible]
    and status != 'offline'
    and sn.screen_id not in (Select friend_screen_id from jb_friends where user_id = :user_id)
    ORDER BY any_user_id    
" {
    set online_any($service) $status
    multirow append other_status $any_user_id $screen_id $first_names $last_name $service $status [jb_create_jid $im_screen_name $service] [jb_best_chat $any_user_id] 
    set any_is_online_p 1
} 

} else {

db_foreach get_all_other_users_online "
    select pr.first_names , pr.last_name , 
    (pr.person_id) as any_user_id , sn.screen_id, sn.status, sn.service, sn.im_screen_name
    from persons pr , jb_screens sn 
    where pr.person_id = sn.user_id 
    and sn.user_id != :user_id
    and sn.user_id NOT IN [tcl_to_oracle_list $all_invisible]
    and status != 'offline'
    and sn.screen_id not in (Select friend_screen_id from jb_friends where user_id = :user_id)
    ORDER BY last_name    
" {
    set online_any($service) $status
    multirow append other_status $any_user_id $screen_id $first_names $last_name $service $status [jb_create_jid $im_screen_name $service] [jb_best_chat $any_user_id] 
    set any_is_online_p 1
} 

}