# form_id optional, if form_id is blank we generate a form just for this question
# question_id
# response_id optional
#
if {![exists_and_not_null response_id]} {
    set response_id ""
}

if {![exists_and_not_null form_id]} {
    set form_id "form_${section_id}"
    ad_form -name $form_id -form [list section_${section_id}:text(hidden)]
}

survey::form::add_survey_section \
    -form $form_id \
    -section_id $section_id \
    -response_id $response_id

db_multirow questions get_questions "select s.survey_id, s.sort_key, s.name as name, question_id, question_text, presentation_type, sort_order, active_p, required_p, s.block_section_p,
     s.section_id as section_id, branch_p
     from survey_questions q, survey_sections s
     where s.section_id=:section_id
     and q.section_id = s.section_id
     order by sort_order" 