create or replace view survey_responses_latest as
select sr.*, o.creation_date, 
       o.creation_user,
       o2.creation_user as initial_user_id
  from survey_responses sr 
  join acs_objects o
    on (sr.response_id = o.object_id)
  join acs_objects o2
    on (coalesce(sr.initial_response_id, sr.response_id) = o2.object_id)
  join (select max(response_id) as response_id
          from survey_responses
         group by survey_response__initial_response_id(response_id)) latest
    on (sr.response_id = latest.response_id);

drop function survey_response__initial_user_id;