<?xml version="1.0"?>
<queryset>

<fullquery name="survey::form::add_survey_section.get_questions">
<querytext>
        select question_id
        from survey_questions
        where section_id=:section_id 
        order by sort_order
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.get_question_properties">      
<querytext>
        select section_id,
               sort_order,
               question_text,
               abstract_data_type,
               required_p,
               active_p,
               presentation_type,
               presentation_options,
               presentation_alignment,
               creation_user,
               creation_date,
               predefined_question_id
        from   survey_questions,
               acs_objects
        where  object_id = question_id
               and question_id = :question_id
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.predefined_question_data">      
<querytext>
            select action_type,
                   abstract_data_type,
                   table_name,
                   column_name,
                   key_name
            from survey_predefined_questions 
            where predefined_question_id = :predefined_question_id
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.locate_predef_preselect">      
<querytext>
select question_id as preselect_question_id,
       object_id as response_id
from survey_question_responses,
     acs_objects
where question_id in (select question_id 
                      from survey_questions 
                      where predefined_question_id = :predefined_question_id
                      )
and object_type = 'survey_response'
and response_id = object_id
and creation_date = (select min(creation_date) 
                     from survey_question_responses, 
                     acs_objects
                     where question_id in (select question_id 
                                           from survey_questions 
                                           where predefined_question_id = :predefined_question_id
                                           )
                     and object_type = 'survey_response'
                     and response_id=object_id
                     )
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.prev_response_query_predef">      
<querytext>
                    select choice_id,
                           boolean_answer,
                           clob_answer,
                           number_answer,
                           varchar_answer,
                           to_char(date_answer,'YYYY MM DD HH24 MI SS') as date_answer,
                           attachment_answer
                    from survey_question_responses
                    where question_id = :preselect_question_id
                    and response_id = :response_id
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.prev_response_query">      
<querytext>
                select choice_id,
                boolean_answer,
                clob_answer,
                number_answer,
                varchar_answer,
                to_char(date_answer,'YYYY MM DD HH24 MI SS') as date_answer,
                attachment_answer
                from survey_question_responses
                where question_id = :question_id
                and response_id = :response_id
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.question_choices">      
<querytext>
                    select choice_id, 
                          label
                    from survey_question_choices
                    where question_id = :question_id
                    order by sort_order
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.get_pretty_value">      
<querytext>
                    select label
                    from survey_question_choices
                    where choice_id = :user_value
</querytext>
</fullquery>

<fullquery name="survey::form::get_response_text.choice_text_value">      
<querytext>
	select varchar_answer
	from survey_question_responses
	where response_id = :response_id
	and question_id = :question_id
	and choice_id is null
</querytext>
</fullquery>

<fullquery name="survey::form::get_response_text.boolean_text_value">      
<querytext>
	select varchar_answer
	from survey_question_responses
	where response_id = :response_id
	and question_id = :question_id
	and boolean_answer is null
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.get_choice_label">      
<querytext>
                    select label
                    from survey_question_choices
                    where choice_id in ($user_value)
</querytext>
</fullquery>

<fullquery name="survey::form::create_ad_form_element.question_choices_all">      
<querytext>
                select * 
                from survey_question_choices
                where question_id = :question_id
                order by sort_order
</querytext>
</fullquery>

</queryset>