ad_library {
    Setup procedures for survey

    @author Dave Bauer (dave@thedesignexperience.org)
    @creation-date 2004-09-17
    @arch-tag: 1ed1eb73-3cbf-463e-bb0c-d798c81bc9f0
    @cvs-id $Id: survey-install-procs.tcl,v 1.1 2005/03/26 18:17:22 jeffd Exp $
}

namespace eval ::survey::install {}

ad_proc -public ::survey::install::package_install {
} {
    Procedure sets up survey package details that need to be run once
    when the package is initially installed.

    @author Dave Bauer (dave@thedesignexperience.org)
    @creation-date 2004-09-17

    @return

    @error
} {
    survey::install::register_search_sc
}


ad_proc -private survey::install::register_search_sc {
} {
    Setup search service contract

    @author Dave Bauer (dave@thedesignexperience.org)
    @creation-date 2004-07-26

    @return

    @error
} {

    foreach spec {
        {
            name "survey"
            aliases {
                datasource survey::search::survey::datasource
                url survey::search::survey::url
            }
            contract_name {FtsContentProvider}
            owner "survey"
        }
        {
            name "survey_section"
            aliases {
                datasource survey::search::section::datasource
                url survey::search::section::url
            }
            contract_name {FtsContentProvider}
            owner "survey"
        }
        {
            name "survey_question"
            aliases {
                datasource survey::search::question::datasource
                url survey::search::question::url
            }
            contract_name {FtsContentProvider}
            owner "survey"
        }
    } {
        acs_sc::impl::new_from_spec -spec $spec
    }
}

ad_proc -private ::survey::install::unregister_search_sc {
} {
    Remove service contacts for uninstall

    @author Dave Bauer (dave@thedesignexperience.org)
    @creation-date 2004-09-17

    @return

    @error
} {
    foreach contract {survey survey_section survey_question} {
        acs_sc::impl::delete \
            -contract_name FtsContentProvider \
            -impl_name $contract
    }
}

ad_proc -public ::survey::install::package_uninstall {
} {
    Removes dependent objects that would prevent uninstall
    that are not handled in the drop script.

    @author Dave Bauer (dave@thedesignexperience.org)
    @creation-date 2004-09-17

    @return

    @error
} {
    survey::install::unregister_search_sc
}

