ad_page_contract {
    Present form to begin adding a question to a survey.
    For Questions in a block section
    Lets user enter the question. Presentation and choices are determined by the type of section (block section)

    @param section_id    integer designating survey we're adding question to
    @param after        optinal integer denoting position of question within survey

    @author  jsc@arsdigita.com
    @author  nstrug@arsdigita.com
    @date    February 9, 2000
    @cvs-id $Id: block-question-add.tcl,v 1.4 2005/03/16 12:26:31 jeffd Exp $
} {
    section_id:integer
    {after:integer ""}
    
}

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]
ad_require_permission $package_id admin

get_survey_info -section_id $section_id
get_section_info -section_id $section_id

if {$section_info(block_section_p)!="t"} {
    ad_complain 1 "Not a measurement section"
}

set question_id [db_nextval "acs_object_id_seq"]
set type $survey_info(type)
ad_form -name create_question -action question-add-3  -export { after } -form {
    {question_id:text(hidden) {value $question_id}}
    {section_id:text(hidden) {value $section_id}}
    {question_text:text(textarea) {label "[_ survey.Question]"}  {html {rows 5 cols 70}}}   
    {abstract_data_type:text(hidden) {value "[_ survey.choice]"}}
    {presentation_type:text(hidden) {value "[_ survey.radio]"}}
    {presentation_alignment:text(hidden) {value "[_ survey.beside]"}}
    {required:text(radio)     {label "[_ survey.Required]"} {options {{Yes t} {No f}}} {value t}}
    {valid_responses:text(hidden) {value "[_ survey.block]"}}
    {type:text(hidden) {value $type}}
}

set survey_id $survey_info(survey_id)
set context [list [list "one?[export_url_vars survey_id]" $survey_info(name)] [_ survey.Add_A_Question]]

if {[ad_parameter allow_question_deactivation_p] == 1} {
    ad_form -extend -name create_question -form {
        {active:text(radio)     {label "[_ survey.Active]""} {options {{Yes t} {No f}}} {value t}}
    } 
} else {
    ad_form -extend -name create_question -form {
        {active:text(hidden) {value t}}
    }
}
    
ad_return_template
