ad_page_contract {
    Add a condition to an existing branch
} {
    branch_id:integer,notnull
    section_id:integer,notnull
    condition_id:integer,notnull
    choice:notnull
} -validate {
    choice_format -requires {choice:notnull} {
	if {!([regexp {^[0-9]+:[0-9]+$} $choice] || [regexp {^[0-9]+:[tf]$} $choice])} {
	    ad_complain "[_ survey.Invalid_Choice]"
	}
    }
}

set package_id [ad_conn package_id]
set user_id [ad_get_user_id]
ad_require_permission $package_id admin

get_survey_info -section_id $section_id
set survey_id $survey_info(survey_id)

set choice_id [db_null]
set boolean_answer [db_null]
regexp {^([0-9]+):([0-9]+)$} $choice match question_id choice_id
regexp {^([0-9]+):([tf])$} $choice match question_id boolean_answer

db_transaction {
    if {[db_0or1row get_old_condition ""]} {
	db_dml unlink_old_condition ""
	db_dml remove_old_condition ""
    }
    db_dml add_condition ""
    db_dml link_condition ""
} on_error {
    
    db_release_unused_handles
    ad_return_error "[_ survey.Database_Error_test]" "<pre>$errmsg</pre>"
    ad_script_abort
    
}


ad_returnredirect "one?survey_id=$survey_id"

