ad_page_contract {

    Modify question responses and scores

    @param question_id   which question we'll be changing responses of
    @param section_id     survey providing this question

    @author Nick Strugnell (nstrug@arsdigita.com)
    @date   September 15, 2000
    @cvs-id $Id: modify-responses.tcl,v 1.1 2003/09/19 16:48:04 rmello Exp $
} {

    question_id:integer
    section_id:integer

}

ad_require_permission $section_id admin

get_survey_info -section_id $section_id
set survey_id $survey_info(survey_id)

set survey_name [db_string survey_name_from_id {} ]

set question_text [db_string survey_question_text_from_id {} ]

set table_html "<table border=0>
<tr><th>Response</th>"

set variable_id_list [list]

db_foreach get_variable_names {} {

      lappend variable_id_list $variable_id
      append table_html "<th>$variable_name</th>"
  }

append table_html "</tr>\n"

set choice_id_list [list]

db_foreach get_choices {} {
    lappend choice_id_list $choice_id
    append table_html "<tr><td align=center><input name=\"responses\" value=\"$label\" size=80></td>"

    db_foreach get_scores {} {

	  append table_html "<td align=center><input name=\"scores.$variable_id\" value=\"$score\" size=2></td>"
      }

    append table_html "</tr>\n"
}

append table_html "</table>\n"

db_release_unused_handles

doc_return 200 text/html "[ad_header "Modify Responses"]
<h2>$survey_name</h2>

[ad_context_bar [list "one?[export_url_vars survey_id]" $survey_info(name)] "Modify Question Responses"]

<hr>

Question: $question_text
<p>
<form action=\"modify-responses-2\" method=get>
[export_form_vars section_id question_id choice_id_list variable_id_list]
$table_html
<p>
<center>
<input type=submit value=\"Submit\">
</center>

</form>

[ad_footer]
"
