ad_page_contract {

    Edit the name of the survey

    @param  section_id  integer denoting survey whose description we're changing

    @author Jin Choi (jsc@arsdigita.com) 
    @author nstrug@arsdigita.com
    @date   February 16, 2000
    @cvs-id $Id: name-edit.tcl,v 1.5 2005/03/23 22:23:40 jeffd Exp $
} {

    survey_id:integer
    {name ""}
}

get_survey_info -survey_id $survey_id
set survey_name_unquoted $survey_info(name_unquoted)
set survey_name $survey_info(name)
set survey_description $survey_info(description_unquoted)
set html_p $survey_info(description_html_p)


ad_require_permission $survey_id admin

ad_form -name edit-name -form {
    survey_id:key
    {name:text {label "[_ survey.Survey_Name_1]"} {html {size 80}}
	{value $survey_name_unquoted}}
    {description:richtext,optional {label "[_ survey.Description_1]"} 
        {value $survey_description}}
} -validate {
    {name {[string length $name] <= 4000} "[_ survey.lt_Survey_Name_must_be_l]"}
} -edit_request {
    set name $survey_name_unquoted
    set description [template::util::richtext::create $survey_description [ad_decode $html_p t "text/html" "text/plain"]]
} -edit_data {
    set description_html_p t
    set description [template::util::richtext::get_property html_value $description]
    db_dml survey_update ""
    ad_returnredirect "one?[export_vars survey_id]"
    ad_script_abort
}

set context [list [list "one?[export_vars survey_id]" $survey_name] [_ survey.Edit_Name]]

ad_return_template


