ad_page_contract {

    Display the filled-out survey for a single user.

    @param  user_id    user whose response we're viewing
    @param  section_id  survey we're viewing
    @author jsc@arsdigita.com
    @author nstrug@arsdigita.com
    @date   February 11, 2000
    @cvs-id $Id: one-respondent.tcl,v 1.3 2005/03/16 12:26:31 jeffd Exp $
} {

    user_id:integer
    survey_id:integer

} 

ad_require_permission $survey_id admin

get_survey_info -survey_id $survey_id
set survey_name $survey_info(name)
set description $survey_info(description)
set type $survey_info(type)

# survey_name and description are now set 

set user_exists_p [db_0or1row user_name_from_id "" ]

if { !$user_exists_p } {
    ad_return_error "[_ survey.Not_Found] "[_ survey.lt_Could_not_find_user_u]"
    return
}

set context [list [_ survey.One_Respondent]]
 

db_multirow -extend {response_display} responses get_responses {} {
set response_display [survey_answer_summary_display $response_id 1 ]
}

ad_return_template
