ad_page_contract {

    This page allows the admin to administer a single survey.

    @param  section_id integer denoting survey we're administering

    @author jsc@arsdigita.com
    @author nstrug@arsdigita.com
    @author dave@thedesignexperience.org
    @date   February 9, 2000
    @cvs-id $Id: one.tcl,v 1.6 2005/03/23 22:23:40 jeffd Exp $
} {

    survey_id:integer
    {section_id:integer ""}
}

set package_id [ad_conn package_id]

ad_require_permission $package_id admin

# Get the survey information.
get_survey_info -survey_id $survey_id
if {![info exists survey_info(survey_id)]} {
    ad_return_complaint 1 "[_ survey.lt_Requested_survey_does]"
    ad_script_abort
}
# get users and # who responded etc...
if {[apm_package_installed_p dotlrn]} {
    set community_id [dotlrn_community::get_community_id_from_url]
    set n_eligible [db_string n_eligible {}]
}
set return_html ""

set creation_date [util_AnsiDatetoPrettyDate $survey_info(creation_date)]
set public_p $survey_info(public_p)
set user_link [acs_community_member_url -user_id $survey_info(creation_user)]
if {$survey_info(single_response_p) == "t"} {
    set response_limit_toggle "[_ survey.allow_multiple]"
} else {
    set response_limit_toggle "[_ survey.limit_to_one]"
}


# allow site-wide admins to enable/disable surveys directly from here
set target "one?[export_url_vars survey_id]"
set enabled_p $survey_info(enabled_p)
set toggle_enabled_url "survey-toggle?[export_vars {survey_id enabled_p target}]"
if {$enabled_p == "t"} {
    append toggle_enabled_text "[_ survey.disable]"
} else {
    append toggle_enabled_text "[_ survey.enable]"
}


# Display Type (ben)
# provide list survey_display_types to adp process with <list>
set survey_display_types [survey_display_types]


# Questions summary.   
# We need to get the questions for ALL sections.

set context $survey_info(name_unquoted)

# form for response upload
ad_form -name import_responses -action import-responses -html {enctype multipart/form-data} -form {
    {survey_id:text(hidden) {value $survey_id}}
    {csvfile:file {label File}}
}

# form for selection of style
set styles [db_list_of_lists styles ""]
set style  [db_string get_style ""]
ad_form -name style_select -action style-select -form {
    {survey_id:text(hidden) {value $survey_id}}
    {style:integer(select) {label Style} {options $styles} {value $style}}
}

set notification_chunk [notification::display::request_widget \
    -type survey_response_notif \
    -object_id $survey_id \
    -pretty_name $survey_info(name_unquoted) \
    -url [ad_conn url]?survey_id=$survey_id \
]

ad_form -name admin_survey -form {
    {survey_id:text(hidden) {value $survey_id}}
}

set last_section_id ""
db_multirow -extend {question_display branch_text} sections survey_questions "" {
    if {$section_id != $last_section_id} {
	get_section_info -section_id $section_id
	template::form::section admin_survey $section_info(name_unquoted)
	if {$branch_p == "t"} {
	    if {[db_0or1row branchquestion ""]} {
		if {$abstract_data_type == "boolean"} {
		    set bchoice [ad_decode $boolean_answer "t" "Yes" "No"]
		} else {
		    db_1row branchchoice ""
		}
		set branch_text "[_ survey.lt_Branch_is_displayed_i] (<a href=\"condition-add?section_id=$section_id\">[_ survey.Change]</a>)"
	    } else {
		set branch_text "[_ survey.No_condition_defined]. <a href=\"condition-add?section_id=$section_id\">[_ survey.Add_one]</a>"
	    } 
	} else {
	    set branch_text ""
	}
    }
    if {![empty_string_p $question_id]} {
	survey::form::create_ad_form_element -form admin_survey -question_id $question_id 
    }
}

ad_return_template
