<?xml version="1.0"?>
<queryset>

<fullquery name="survey_number_responses">
<querytext>
	select count(*)
	from survey_question_responses
	where question_id=:question_id
</querytext>
</fullquery>

<fullquery name="presentation">
<querytext>
select presentation_type, presentation_options, abstract_data_type,
sort_order as anchor
from survey_questions
where question_id=:question_id
</querytext>
</fullquery>

<fullquery name="sections">
<querytext>
	select name,section_id from survey_sections
	where survey_id=:survey_id and block_section_p='f'
	order by sort_key
</querytext>
</fullquery>

<fullquery name="survey_question_valid_responses">
<querytext>
select label,numeric_value from survey_question_choices
where question_id=:question_id
order by sort_order
</querytext>
</fullquery>


<fullquery name="survey_question_details">      
      <querytext>
select 
	question_id,
	question_text,
	abstract_data_type,
	presentation_alignment,
	presentation_options,
	sort_order as question_number,
	required_p,
	sort_order,
        pretty_id
from survey_questions
where question_id = :question_id
      </querytext>
</fullquery>

<fullquery name="new_anchor">
<querytext>
	select max(sort_order) from survey_questions where question_id=:question_id
</querytext>
</fullquery>

<fullquery name="survey_question_update">
<querytext>
update survey_questions
     set question_text=:question_text,
	 section_id=:section_id,
	 sort_order=:anchor,
         active_p=:active_p,
         required_p=:required_p,
	 presentation_type=:presentation_type,
	presentation_options=:presentation_options,
        pretty_id=:pretty_id
     where question_id=:question_id
</querytext>
</fullquery>

<fullquery name="get_choice_id">
<querytext>
        select choice_id from survey_question_choices
        where question_id=:question_id
        order by sort_order
</querytext>
</fullquery>

<fullquery name="insert_new_choice">
<querytext>
insert into survey_question_choices
(choice_id, question_id, label, sort_order)
values (:new_choice_id, :question_id, :choice_label, :sort_order)
</querytext>
</fullquery>

<fullquery name="update_new_choice">
<querytext>
update survey_question_choices
                set label=:choice_label where choice_id=:choice_id_to_update
</querytext>
</fullquery>

<fullquery name="delete_old_choice">
<querytext>
delete from survey_question_choices where choice_id = :choice_id_to_delete
</querytext>
</fullquery>






<fullquery name="survey_name_from_id">      
      <querytext>
      select name from survey_sections where section_id=:section_id
      </querytext>
</fullquery>


</queryset>
