ad_page_contract {
    Present form to begin adding a section to a survey.
    Lets user enter the section and select a presentation type.

    @param survey_id    integer designating survey we're adding question to
    @param after        optinal integer denoting position of section within survey

    @author  jsc@arsdigita.com
    @author  nstrug@arsdigita.com
    @date    February 9, 2000
    @cvs-id $Id: section-add.tcl,v 1.4 2005/03/16 12:26:31 jeffd Exp $
} {
    survey_id:integer
    
}

set package_id [ad_conn package_id]
set user_id [ad_get_user_id]
ad_require_permission $package_id admin

set next_section_id [db_nextval acs_object_id_seq]

ad_form -name create_section -action section-add-2 -form {
    {section_id:text(hidden) {value $next_section_id}}
    {survey_id:text(hidden) {value $survey_id}}
    {name:text(text) {label "[_ survey.Section_Name]"} {html {size 30}}}
    {pretty_id:text {label "Variable name"} 
        {help_text "This will be the name of the variable when creating reports. No spaces or special characers."}
        {value $next_section_id}
    }
    {description:text(textarea) {label "[_ survey.Description_1]"}  {html {rows 5 cols 70}}}   
    {description_html_p:text(radio)     {label "[_ survey.lt_The_above_description]"} {options {{HTML t} {"[_ survey.Plain_text]" f}}} {value f}}
    {branch_p:text(radio) {label "[_ survey.Branch]"} {options {{Yes t} {No f}}} {value f}}
    {page_break_p:text(radio) {label "[_ survey.lt_Begin_new_Page_after_]"} {options {{Yes t} {No f}}} {value t}}
}

set poslist [list [list "[_ survey.First_Section]" 0]]
db_foreach positions "" {
    lappend poslist [list $secname $secsortkey]
}
set lastsec $secsortkey

ad_form -extend -name create_section -form {
    {after:integer(Select) {label "[_ survey.Position]"} {options $poslist} {value $lastsec}}
}

get_survey_info -survey_id $survey_id
set context [list [list "one?[export_url_vars survey_id]" $survey_info(name)] [_ survey.Add_A_Section]]

ad_return_template

