<?xml version="1.0"?>

<queryset>

<fullquery name="get_section_info">
      <querytext>
      select branch_p as old_branch_p, branched_p as old_branched_p,
      block_section_p as old_block_section_p
      from survey_sections where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="referring_sort_key">
      <querytext>
      select s.sort_key as refers_to, condition from survey_sections s, survey_branches b, survey_conditions c,
      survey_questions q where b.section_id=:section_id and b.condition=c.condition_id and
      c.question_id=q.question_id and q.section_id=s.section_id
      </querytext>
</fullquery>

<fullquery name="old_sort_key"> 
      <querytext>
      select sort_key from survey_sections where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="dependant">
      <querytext>
      select min(s.sort_key) from survey_sections s, survey_branches b, survey_conditions c,
      survey_questions q where q.section_id=:section_id and b.condition=c.condition_id and
      c.question_id=q.question_id and b.section_id=s.section_id
      </querytext>
</fullquery>


<fullquery name="make_block_section">
      <querytext>
      insert into
      survey_block_sections(block_section_id,section_id,answer_description)
      values (:block_id,:section_id,'')
      </querytext>
</fullquery>

<fullquery name="make_block_choices">
      <querytext>
      insert into
      survey_block_questions(block_section_id,choice_id,label,sort_order)
      select
      :block_id,:choice_id,label,sort_order
      from survey_question_choices where question_id=:question_id
      </querytext>
</fullquery>

<fullquery name="mark_block_section">
      <querytext>
      update survey_sections set block_section_p='t' where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="mark_noblock_section">
      <querytext>
      update survey_sections set block_section_p='f' where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="remove_block_questions">
      <querytext>
      delete from survey_block_questions where  block_section_id in (select block_section_id from survey_block_sections where section_id=:section_id)
      </querytext>
</fullquery>

<fullquery name="remove_block_sections">
      <querytext>
      delete from survey_block_sections where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="block_sections">
      <querytext>
	select block_section_id from survey_block_sections where section_id=:section_id order by block_section_id
      </querytext>
</fullquery>

<fullquery name="add_answer_description">
      <querytext>
	update survey_block_sections set answer_description=:answer_description where block_section_id=:block_section_id
      </querytext>
</fullquery>


<fullquery name="modify_branch"> 
      <querytext>
      update survey_branches set after=(select section_id from
      survey_sections where survey_id=:survey_id and sort_key=:after), condition=null
      where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="drop_condition"> 
      <querytext>
      delete from survey_conditions where condition_id=:condition
      </querytext>
</fullquery>

<fullquery name="remove_sort_key">      
      <querytext>
      update survey_sections set sort_key=sort_key-1 where
      sort_key>(select sort_key from survey_sections where
      section_id=:section_id) and survey_id=:survey_id
      </querytext>
</fullquery>

<fullquery name="reorder_sort_key">      
      <querytext>
      update survey_sections set sort_key=sort_key+1 where
      sort_key>=:sort_key and survey_id=:survey_id
      </querytext>
</fullquery>

<fullquery name="modify_section">
      <querytext>
      update survey_sections set name=:name, description=:description,
      description_html_p=:description_html_p, sort_key=:sort_key,
      branch_p=:branch_p, page_break_p=:page_break_p where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="add_branch">
      <querytext>
      insert into
      survey_branches(branch_id,section_id,after,condition) values (
      :branch_id,:section_id,(select section_id from survey_sections
      where survey_id=:survey_id and sort_key=:after),null)
      </querytext>
</fullquery>


<fullquery name="drop_branch">
      <querytext>
      delete from survey_branches where section_id=:section_id
      </querytext>
</fullquery>
















<fullquery name="old_parent_section"> 
      <querytext>
      select after as old_parent_section,condition from survey_branches where section_id=:section_id
      </querytext>
</fullquery>

<fullquery name="new_parent_section"> 
      <querytext>
      select section_id as new_parent_section from survey_sections where
      survey_id=:survey_id and sort_key=:after
      </querytext>
</fullquery>




 </queryset>
