ad_page_contract {

    Allow the user to modify a section.

    @param   section_id   section we're changing

    @author  cmceniry@arsdigita.com
    @author  nstrug@arsdigita.com
    @author  openacs@sussdorff.de
    @date    Jun 16, 2000
    @cvs-id  $Id: section-edit.tcl,v 1.5 2005/03/16 12:26:31 jeffd Exp $
} {

    section_id:integer
}

get_survey_info -section_id $section_id
set survey_name $survey_info(name)
set survey_id $survey_info(survey_id)
ad_require_permission $survey_id admin

ad_form -name modify_section -action section-edit-2 -form {
    {section_id:text(hidden) {value $section_id}}
}

db_1row section_info ""
set poslist [list [list "First Section" 0]]
db_foreach positions "" {
    lappend poslist [list $secname $secsortkey]
}

if { ![exists_and_not_null pretty_id] } {
    set pretty_id $section_id
}

ad_form -extend -name modify_section -form {
    {name:text(text) {label "[_ survey.Section_Name]"} {html {size 30}} {value $name}}
    {pretty_id:text {label "Variable name"} {value $pretty_id }
        {help_text "This will be the name of the variable when creating reports. No spaces or special characers."}
    }
    {description:text(textarea) {label "[_ survey.Description_1]"}  {html {rows 5 cols 70}} {value $description}}
    {description_html_p:text(radio)     {label "[_ survey.lt_The_above_description]"} {options {{HTML t} {"[_ survey.Plain_text]" f}}} {value $description_html_p}}
    {branch_p:text(radio) {label "[_ survey.Branch]"} {options {{Yes t} {No f}}} {value $branch_p}}
    {after:integer(Select) {label "[_ survey.Position]"} {options $poslist} {value $after}}
    {page_break_p:text(radio) {label "[_ survey.lt_New_Page_after_this_s]"} {options {{Yes t} {No f}}} {value $page_break_p}}
}

if {$block_section_p=="t" || [survey_block_section_candidate_p $section_id]} {
    set answer_descriptions [join [db_list answer_descriptions ""] "\n"]
    ad_form -extend -name modify_section -form {
	{block_section_p:text(radio) {label "[_ survey.Measurement_Section]"} {options {{Yes t} {No f}}} {value $block_section_p}}
	{answer_descriptions:text(textarea),optional {label "[_ survey.lt_Answer_descriptions_o]"} {value $answer_descriptions}}
    }
} else {
    ad_form -extend -name modify_section -form {
	{block_section_p:text(hidden) {value $block_section_p}}
    }    
}

if {[file exists "[template::get_resource_path]/forms/survey/sections/${section_id}.adp"]} {
    set template_exists "t"
} else {
    set template_exists "f"
}

set context [list [_ survey.Edit_Section]]

ad_return_template
